//---------------------------------------------------------------------------
#ifndef TPushKeysH
#define TPushKeysH
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>

//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// types for this class
//window title match options
enum PKWindowMatch {wmExactMatch,wmStartMatch,wmPartialMatch};

//events
typedef void __fastcall (__closure *TxPushKeyKeyEvent)(System::TObject* Sender,AnsiString &Key,TShiftState &KeyState);
typedef void __fastcall (__closure *TxPushKeyPushEvent)(System::TObject* Sender, HWND &hWnd,bool &Activate,HANDLE &Process,DWORD &Wait);


//---------------------------------------------------------------------------
class PACKAGE TPushKeys : public TComponent
{
private:
        //key string
        AnsiString fKeys;

        //title of window to be targeted
        AnsiString fWindowTitle;
        //window title match
        PKWindowMatch fWinMatch;
        //default inter keypress delay (mS)
        int fDelay;
        //calculated inter-key press delay value
        int KeyDelayValue;

        //is push routine still running
        bool fIsPushing;

        //is ANSI keys (PushDOSKeys)
        bool fUseANSI;

        //return focus ti application?
        bool fReturnFocus;

        void __fastcall SetKeys(AnsiString keys);
        void HandleOnKeyEvent(AnsiString &Key,TShiftState &ShiftState);

        HWND TargetWindow;

        //process handle & delay times
        HANDLE Process;
        DWORD ProcessWait;

        //events
        TxPushKeyKeyEvent fOnKey;
        TxPushKeyPushEvent fOnPush;

        //internal functions
        void FindWindowTitle();
        friend BOOL __stdcall ListWindows(HWND hWnd, LPARAM lparam);
        //friend void OnKeyHandler(bool IsFnKey,AnsiString Key);
        void DoKeyDelay();
        HWND __fastcall PushMethod(AnsiString k);

protected:

public:
        __fastcall TPushKeys(TComponent* Owner);
        __property bool IsPushing={read=fIsPushing,default=false};
        HWND __fastcall Push();
        HWND __fastcall Push(AnsiString k);

__published:
    __property AnsiString Keys={read=fKeys,write=SetKeys,default='\0'};
    __property AnsiString WindowTitle={read=fWindowTitle,write=fWindowTitle,default='\0'};
    __property PKWindowMatch TitleMatch={read=fWinMatch,write=fWinMatch,default=wmExactMatch};
    __property int KeyDelay={read=fDelay,write=fDelay,default=0};
    __property bool UseANSI={read=fUseANSI,write=fUseANSI,default=false};
    __property bool ReturnFocus={read=fReturnFocus,write=fReturnFocus,default=false};

    //events
    __property TxPushKeyKeyEvent OnKey = {read=fOnKey, write=fOnKey};
    __property TxPushKeyPushEvent OnPush = {read=fOnPush, write=fOnPush};


};
//---------------------------------------------------------------------------
#endif

