//---------------------------------------------------------------------------
//C++Builder demo of TPushkeys component
//Alan Warriner
//alan.warriner@bigfoot.com
//http://www.alan-warriner.co.uk
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
#include "stdlib.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
void FillList();
BOOL __stdcall ListTheWindows(HWND hWnd, LPARAM lparam);
void ShowForm2();

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
//clear Onkey event list
ListView1->Items->Clear();

//setup pushkeys
PushKeys1->WindowTitle=ListBox1->Items->Strings[ListBox1->ItemIndex];
PushKeys1->ReturnFocus=returnfocus->Checked;
PushKeys1->UseANSI=UseAnsi->Checked;
PushKeys1->TrackTarget=tracktarget->Checked;
PushKeys1->KeyDelay=keyrate->Checked ? -1:0;

//send keys
if (PushKeys1->Push(Edit1->Text)==NULL)
        {
        Beep();
        Application->MessageBox("Could Not Find Target Window","Window Error",MB_OK | MB_ICONEXCLAMATION);
        }
}
//---------------------------------------------------------------------------
//refresh window list
void __fastcall TForm1::Button2Click(TObject *Sender)
{
//fill list box
ShowForm2();
}
//---------------------------------------------------------------------------
//fill list box with window titles
void FillList()
{
Form1->ListBox1->Clear();

EnumWindows((WNDENUMPROC)ListTheWindows,0);

Form1->Label1->Caption=IntToStr(Form1->ListBox1->Items->Count)+" Windows";

Form1->ListBox1->ItemIndex=0;
}
//---------------------------------------------------------------------------
//enum windows proc used to fill list box with window titles
BOOL __stdcall ListTheWindows(HWND hWnd, LPARAM lparam)
{
char buf[255];

GetWindowText(hWnd,buf,255);

if (lstrlen(buf)>0)
        {
        Form1->ListBox1->Items->Add(buf);
        }


return true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormShow(TObject *Sender)
{
//seed random numbers
randomize();

//show other form & fill list box
ShowForm2();

}
//---------------------------------------------------------------------------
//show other form and select in list box
void ShowForm2()
{
//initially select our test window
Form2->Show();

//position it
Form2->Left=Form1->Left+Form1->Width;

//populate window list
FillList();

//select form2 in list
for (int i=0;i<Form1->ListBox1->Items->Count;i++)
        {
        if (Form1->ListBox1->Items->Strings[i]==Form2->Caption)
                {
                Form1->ListBox1->ItemIndex=i;
                break;
                }
        }

}
//---------------------------------------------------------------------------
//exit
void __fastcall TForm1::Button3Click(TObject *Sender)
{
Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
//close help
Application->HelpCommand(HELP_QUIT, 0);

}
//---------------------------------------------------------------------------
//help
void __fastcall TForm1::Button4Click(TObject *Sender)
{
Application->HelpFile = ExtractFilePath(Application->ExeName)+"TPushKeys.hlp";
Application->HelpCommand(HELP_CONTENTS, 0);
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------

void __fastcall TForm1::PushKeys1Key(TObject *Sender, AnsiString &Key,
      TShiftState &KeyState)
{
//fill listview with keys & state
TListItem *tli;

tli=ListView1->Items->Add();
tli->SubItems->Add(Key);
AnsiString ss;

//shift?
ss=KeyState.Contains(ssShift) ? "True":"False";
tli->SubItems->Add(ss);
//ctrl
ss=KeyState.Contains(ssCtrl) ? "True":"False";
tli->SubItems->Add(ss);
//alt
ss=KeyState.Contains(ssAlt) ? "True":"False";
tli->SubItems->Add(ss);
      
}
//---------------------------------------------------------------------------
